#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/dijkstra_shortest_paths.hpp>
#include <boost/graph/graph_traits.hpp>
#include <boost/graph/graph_utility.hpp>
using namespace std;
using namespace boost;

int main() {
  using Graph = adjacency_list<listS, vecS, directedS, no_property,
    property<edge_weight_t, int >> ;
  using Vertex = graph_traits<Graph>::vertex_descriptor;
  using Edge = pair<int, int>;

  enum vertices { S, A, B, C, D, E, F, Z };//_̖Oij
  const int lastIndex = Z;                 //Ō̐
  string names = "SABCDEFZ";               //_̕\x
  vector<Edge> edges{                      //ӂ̒`
    { S, A },{ S, B },
    { A, B },{ A, C },{ A, D },
    { B, A },{ B, C },{ B, D },
    { C, D },{ C, E },{ C, F },
    { D, A },{ D, B },{ D, F },
    { E, D },{ E, Z },    //ŒZoH
    { F, E },{ F, Z } };  //ŒZoH
    //{ E, D }, { Z, E }, //ŒZoHȂ
    //{ F, E },{ Z, F } };//ŒZoHȂ
  vector<int> weights{//d݂̒`
    3, 5,
    1, 10, 11,
    3, 2, 3,
    2, 7, 12,
    15, 7, 2,
    11, 2,
    3, 2 };
  if (edges.size() != weights.size()) throw runtime_error("ӂ̐Əd݂̐Ȃ");

  Graph g(edges.cbegin(), edges.cend(), weights.cbegin(), lastIndex);//Ot̍\z
  print_graph(g, names.c_str());//Ot̕\
  cout << endl;

  Vertex start = S;//X^[gn_
  vector<Vertex> parents(num_vertices(g));//ŒZoHi[vector
  dijkstra_shortest_paths(g, start, predecessor_map(&parents[0]));//ŒZoH߂

  Vertex goal = Z;//S[n_
  if (parents[goal] == goal) {
    cout << "ŒZoHȂ\n";
    return 1;
  }

  for (Vertex v = goal; v != start; v = parents[v]) {//oH̕\
    cout << names[v] << " <- ";

  }
  cout << names[start] << endl;
}//o͒lFZ <- F <- D <- B <- A <- S